
/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package number1;

import java.util.LinkedHashMap;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.TreeMap;
import java.util.Map;
import java.util.Random;
import java.util.Collections;
import java.util.ArrayList;
import java.util.List;

/**
* class for generating <b>maps</b>
* @author Sofia Iakovleva "sofja.iakovleva@gmail.com"
* @version 1.0
* @see Main
 */
public class Maps{
 /**
 * Field map
  */
  Map map;
  /**
  * Сonstant SEC
  * {@value} Сreated to calculate the time
  *
  */
  final int SEC = 1000;
  /**
  * Сonstant LIMIT
  * {@value} Number of map values
  *
  */
  final int LIMIT = 2000000;

  /**
  * Сonstant GEN
  * {@value} For generate
  *
  */
  final int GEN = 100000;

/**
* Сonstructor for maps
* @param map
 */
  Maps(Map<String, Integer> map){
    this.map = map;
    generateKey();
    generateValues();
    sort();
  }

/**
* Method for generating map keys
* @return generated string key(str)
 */
    public String generateKey(){
    double start = System.currentTimeMillis();
    Random random = new Random();
    String str = "";
    for (int i = 0; i < 10; i++){
      int key = random.nextInt(26);
      str = Integer.toString(key);
    }
    return str;
  }

/**
* Method for generating map values
* @return map
*/
  public void generateValues(){
    double start = System.currentTimeMillis();
    for (int i = 0; i < LIMIT; i++){
      int value = (int)(Math.random() * GEN);
      this.map.put(generateKey(), value);
    }

    double time = System.currentTimeMillis() - start;

    System.out.println("Time generatedValues: " + time/SEC + " sec");
  }

  /**
  * Metod for sort map mapValues
  * @return ArrayList<>
  */

    public void sort(){
      double start = System.currentTimeMillis();

      List<Integer> mapValues = new ArrayList<>(this.map.values());
      Collections.sort(mapValues);

      double time = System.currentTimeMillis() - start;

      System.out.println("Time: " + time/SEC + " sec");
    }


}
